const Loki = require ('lokijs');
const LokiNativeScriptAdapter = require("loki-nativescript-adapter");

const FrameModule = require("ui/frame");
const createViewModel = require("./artists-view-model").createViewModel;
var viewModel;

function onNavigatingTo(args) {
	 var page = args.object;
	 //var searchText = page.navigationContext.searchText;

	 //console.log("searchText:"+searchText);

	if( !viewModel) {
		console.log("onNavigatingTo createViewModel");
		viewModel = createViewModel( global.ldb.getCollection("artists")); 
	}
	page.bindingContext = viewModel;
	console.log("artists onNavigatingTo artistFilter:"+viewModel.artistFilter);
}

function navigateToAlbums(args) {
	 FrameModule.topmost().navigate({moduleName: "albums/albums", animated: false, context: {artistId: args.object.bindingContext.artists.getItem(args.index).artistId}});
}

/*
exports.onArtistFilterChange = function( args) {
	if( args.propertyName == "text") {
		if(args.value.length == 0 || args.value.length > 2) {
			viewModel.artistFilter = args.value;
			console.log("artistFilter="+viewModel.artistFilter);
			viewModel.select();
		}
	}
}
*/
exports.onArtistFilterApply = function( args) {
	viewModel.artistFilter = args.object.text;
	console.log("onArtistFilterApply artistFilter="+viewModel.artistFilter);
	viewModel.select();
}

exports.onGoBack = function( args) {
	FrameModule.topmost().goBack();
}

exports.onNavigatingTo = onNavigatingTo;
exports.navigateToAlbums = navigateToAlbums;
