const Observable = require("data/observable").Observable;
const ObservableArray = require("data/observable-array").ObservableArray;

const LMS = require("../shared/lms").LMS;
const config = require("../shared/config");
const utils = require("../shared/utils");

function createViewModel(collTracks, trackId) {
	const lms = new LMS();

/*
	var trackAttributes = {
		trackTitle:{ text: "Title"},
		trackArtist:{ text: "Artist"},
		trackAlbum:{ text: "Album"},
		trackYear:{ text: "Year"},
		trackTracknum:{ text: "Track number"},
		trackDuration:{ text: "Duration", funct: utils.secsToDuration},
		trackGenres:{ text: "Genre"},
		trackCompilation:{ text: "Compilation"},
		trackDisc:{ text: "Disc"},
		trackDisccount:{ text: "Disc count"},
		trackComment:{ text: "Comment"},
		trackLyrics:{ text: "Lyrics"},
		trackRating:{ text: "Rating", funct: utils.getPrettyRating},
		trackPlaycount:{ text: "Play count"},
		trackBitrate:{ text: "Bitrate"},
		trackSamplerate:{ text: "Samplerate"},
		trackFilesize:{ text: "File size", funct: utils.bytesToSize},
		trackModificationTime:{ text: "Modification time", funct: utils.dateToString},
		trackAddedTime:{ text: "Added time", funct: utils.dateToString},
		trackUrl:{ text: "url", funct: decodeURI},
		trackId:{ text: "id"},
		trackCoverid:{ text: "coverid"},
		trackAlbumId:{ text: "album_id"},
		trackGenre:{ text: "genre"},
		trackArtworkTrackId:{ text: "artwork_track_id"},
		trackGenreId:{ text: "genre_id"},
		trackGenreIds:{ text: "genre_ids"},
		trackArtistId:{ text: "artist_id"}
	};
*/
    var viewModel = new Observable();
    viewModel.trackId = trackId;
    viewModel.trackDetails = "";

    viewModel.select = function() {

		console.log("find trackId="+this.trackId);
		var t = collTracks.chain().find( {'trackId': { '$eq' : this.trackId }}).simplesort("trackTitle").data();

		viewModel.trackDetails += '<head><style>table, th, td { border: 1px solid LightGray; border-collapse: collapse;font-family="sans-serif-condensed,sans-serif";} tr:nth-child(even) {background-color: gainsboro}</style></head><body>\n'; 
		viewModel.trackDetails += '<span class="body"><table>\n'; 
		for( let e of t) {
			for (const tatt of Object.keys(lms.trackAttributes)) {
				if( e[tatt]) {
					viewModel.trackDetails += '<tr><td><strong>' + lms.trackAttributes[tatt].text + "</strong></td> "; 
					if( lms.trackAttributes[tatt].funct) {
						try {
							viewModel.trackDetails += "<td>"+lms.trackAttributes[tatt]['funct'](e[tatt])+"</td></tr>\n";
						} catch( x) {
							viewModel.trackDetails += "<td>"+e[tatt]+"</td></tr>\n";
							console.log(e['trackId']+" Attribute "+tatt + " Element "+e[tatt]+" Error "+x);
						}
					} else {
						viewModel.trackDetails += "<td>"+e[tatt]+"</td></tr>\n";
					}
				}
			}
		}
		viewModel.trackDetails += '</table></span></body>'; 
    }

    viewModel.select();

    return viewModel;
}

exports.createViewModel = createViewModel;
