const FrameModule = require("ui/frame");
const Observable = require("data/observable").Observable;


function createViewModel() {
	var viewModel = new Observable({
		message: "Version 0.1"+String.fromCharCode(0x03b1),
		searchText: "",
		searchIcon: String.fromCharCode(0xf002)
	});

    viewModel.artistsButtonOnTap = function() {
		FrameModule.topmost().navigate({moduleName: "artists/artists", animated: false });
	}
    viewModel.albumsButtonOnTap = function() {
		FrameModule.topmost().navigate({moduleName: "albums/albums", animated: false, context: {artistId: null} });
	}
    viewModel.tracksButtonOnTap = function() {
		FrameModule.topmost().navigate({moduleName: "tracks/tracks", animated: false, context: {albumId: null, artistId: null} });
	}
    viewModel.playlistButtonOnTap = function() {
		FrameModule.topmost().navigate({moduleName: "playlists/playlists", animated: false });
	}
    viewModel.settingsButtonOnTap = function() {
		FrameModule.topmost().navigate({moduleName: "settings/settings", animated: false });
	}

    viewModel.searchOnTap = function() {
		//console.log("search init");
		if( viewModel.searchText.length > 0) {
			FrameModule.topmost().navigate({moduleName: "search/search", animated: false, context: {searchText: viewModel.searchText} });
		}
    }

    return viewModel;
}

exports.createViewModel = createViewModel;