const Observable = require("data/observable").Observable;
const ObservableArray = require("data/observable-array").ObservableArray;

//const LMS = require("../shared/lms").LMS;
const config = require("../shared/config");
const utils = require("../shared/utils");

function createViewModel( lms) {
	//const lms = new LMS();
	var viewModel = new Observable( {
		playlists: new ObservableArray([]),
		isLoading:	false
	});

    viewModel.select = function() {

		lms.checkConn();

		that = this;
		viewModel.isLoading = true;
		while (viewModel.playlists.length) {
			viewModel.playlists.pop();
    	}

		lms.getAllPlaylists()
			.then(function( result) {
				//console.dump( result);
				console.log("getAllPlaylists result size:"+result.length);
				viewModel.playlists.push( result);
				viewModel.isLoading = false;
			},function(error) {
				console.log(error);
				viewModel.isLoading = false;
				lms.showLMSError( error);
			});
    }

    viewModel.select();

    return viewModel;
}

exports.createViewModel = createViewModel;
