const FrameModule = require("ui/frame");
const utilsModule = require("utils/utils");
const config = require("../shared/config");
const createViewModel = require("./search-view-model").createViewModel;

var viewModel;
var page;

exports.onNavigatingTo = function(args) {
	page = args.object;
	var searchText = page.navigationContext.searchText;

	page.getViewById("search-bar").dismissSoftInput();

	if( !viewModel) {
		viewModel = createViewModel(global.ldb, searchText);
	} else {
		viewModel.handleTracks = config.settings.handleTracks;
		if( searchText != viewModel.searchText) {
			//console.log("onNavigatingTo viewModel.searchText="+viewModel.searchText+" searchText="+searchText);
			viewModel.searchText = searchText;
			viewModel.select();
		}
	}
	console.log("onNavigatingTo searchText="+viewModel.searchText+" handleTracks="+viewModel.handleTracks);
	page.bindingContext = viewModel;
}

exports.navigateToTracks = function (args) {
	if( viewModel.handleTracks) {
		FrameModule.topmost().navigate({moduleName: "tracks/tracks", animated: false, context: {albumId: args.object.bindingContext.albums.getItem(args.index).albumId}});
	}
}
exports.navigateToAlbums = function (args) {
	 FrameModule.topmost().navigate({moduleName: "albums/albums", animated: false, context: {artistId: args.object.bindingContext.artists.getItem(args.index).artistId}});
}
exports.navigateToDetails = function (args) {
	 FrameModule.topmost().navigate({moduleName: "details/details", animated: false, context: {trackId: args.object.bindingContext.tracks.getItem(args.index).trackId}});
}
exports.searchOnSubmit = function() {
	if( viewModel.searchText.length > 0) {
		page.navigationContext.searchText = viewModel.searchText;
		viewModel.select();
		//utilsModule.ad.dismissSoftInput();
	}
}

exports.onGoBack = function( args) {
	FrameModule.topmost().goBack();
}

exports.onSearchBarLoaded = function( event) {
	if (event.object.android) {
		event.object.dismissSoftInput();
		event.object.android.clearFocus();
	}
}
	/*
	var searchBar = page.getViewById("search-bar");
	
	searchBar.on(searchBarModule.SearchBar.submitEvent, function (args) { 
		console.log("Search for " + (args.object).text);
	});
	*/