var fractionChars = ['','&frac14;','&frac12;','&frac34;'];

exports.getPrettyRating = function( rating) {
	r="";
	var n = Math.floor(rating/20);
	for( var i = 0; i < n; i++) {
		r = r + "*";
	}
	return r+fractionChars[ Math.floor( (rating-n*20)/5 )];
}

exports.bytesToSize = function (bytes) {
	var sizes = ['bytes', 'KiB', 'MiB', 'GiB', 'TiB', 'PiB', 'EiB', 'ZiB', 'YiB'];
	if (bytes == 0) return 'n/a';
	var i = parseInt(Math.floor(Math.log(bytes) / Math.log(1024)));
	if (i == 0) { return (bytes / Math.pow(1024, i)) + ' ' + sizes[i]; }
	return (bytes / Math.pow(1024, i)).toFixed(1) + ' ' + sizes[i];
}

exports.dateToString = function( timestamp) {
	function pad(n){return n<10 ? '0'+n : n}
	var d = new Date( timestamp*1000);
	return d.getFullYear()+'-'
		+ pad(d.getMonth()+1)+'-'
		+ pad(d.getDate())+' '
		+ pad(d.getHours())+':'
		+ pad(d.getMinutes())+':'
		+ pad(d.getSeconds());
}

exports.secsToDuration = function(s) {
	function pad(x) {return ((x>9)?"":"0")+x}
	var m = Math.floor(s / 60);
	s = s % 60;
	var h = Math.floor(m / 60);
	m = m % 60;
	var d = Math.floor(h / 24);
	h = h % 24;
	return (h != 0?pad(h) + "h ":"") + (m != 0?pad(m)+ "m ":"")+pad( Math.round(s))+ "s";
}