const FrameModule = require("ui/frame");
const createViewModel = require("./tracks-view-model").createViewModel;

var viewModel;

function onNavigatingTo(args) {
    var page = args.object;
	var needSelect = false;

	console.log("tracks: artist="+page.navigationContext.artistId +" albumId="+page.navigationContext.albumId);
	if( !viewModel) {
		viewModel = createViewModel(global.ldb.getCollection("tracks"), page.navigationContext.artistId, page.navigationContext.albumId);
	} else {
		if( viewModel.artistId != page.navigationContext.artistId) {
			viewModel.artistId = page.navigationContext.artistId;
			needSelect = true;
		}
		if( viewModel.albumId != page.navigationContext.albumId) {
			needSelect = true;
			viewModel.albumId = page.navigationContext.albumId;
		}
		if( needSelect) {
			viewModel.select();
		}
	}
	page.bindingContext = viewModel;
}

function navigateToDetails(args) {
	 FrameModule.topmost().navigate({moduleName: "details/details", animated: false, context: {trackId: args.object.bindingContext.tracks.getItem(args.index).trackId}});
}

exports.onTrackFilterChange = function( args) {
	viewModel.trackFilter = args.object.text;
	console.log("trackFilter="+viewModel.trackFilter);
	viewModel.select();
}

exports.onGoBack = function( args) {
	FrameModule.topmost().goBack();
}

exports.onNavigatingTo = onNavigatingTo;
exports.navigateToDetails = navigateToDetails;